Index: branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmPriceOfBudget.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmPriceOfBudget.cs	(revision 50)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmPriceOfBudget.cs	(revision 51)
@@ -75,11 +75,11 @@
             /// </summary>
             DataType1 = 0,
             /// <summary>
-            /// 
+            /// 施工中台帳分合計
             /// </summary>
             DataType2,
             /// <summary>
-            /// 
+            /// 完了工事台帳分合計
             /// </summary>
             DataType3,
             /// <summary>
@@ -92,8 +92,8 @@
         /// 合計行タイトル
         /// </summary>
         private static string[] s_TotalTitleArray = new string[] {  "＊台帳未作成分合計＊",
-                                                                    "＊　　　　　　　　　＊",
-                                                                    "＊　　　　　　　　　＊",
+                                                                    "＊施工中台帳分合計＊",
+                                                                    "＊完了工事台帳分合計＊",
                                                                     "＊＊　総　合　計　＊＊",
                                                                 };
         #endregion
@@ -116,6 +116,8 @@
         /// </summary>
         private DialogResult m_EndButton = DialogResult.None;
 
+        // 合計エリア
+        private int[] m_TotalArea;
         #endregion
 
         #region プロパティ
@@ -162,33 +164,36 @@
         }
         #endregion
 
-        #region 担当者コンボボックス変更
+        #region 部署コンボボックス変更
         /// <summary>
-        /// 担当者変更
+        /// 部署コンボボックス変更
         /// </summary>
         /// <param name="sender"></param>
         /// <param name="e"></param>
-        private void cmbConstructionPerson_SelectedIndexChanged(object sender, EventArgs e)
+        private void cmbDepartment_TextChanged(object sender, EventArgs e)
         {
             if (m_initDataLoad) return;
 
+            // 担当者コンボボックス変更
+            SetcmbPersons();
+
             // データ表示
             DispData();
         }
         #endregion
 
-        #region 部署コンボボックス変更
+        #region 担当者コンボボックス変更
         /// <summary>
-        /// 部署コンボボックス変更
+        /// 担当者コンボボックス変更
         /// </summary>
         /// <param name="sender"></param>
         /// <param name="e"></param>
-        private void cmbDepartment_SelectedIndexChanged(object sender, EventArgs e)
+        private void cmbConstructionPerson_TextChanged(object sender, EventArgs e)
         {
             if (m_initDataLoad) return;
 
-            // 担当者コンボボックス変更
-            SetcmbPersons();
+            // 担当者選択時部署選択を設定する
+            SetPerosonToDepartment();
 
             // データ表示
             DispData();
@@ -228,6 +233,50 @@
         }
         #endregion
 
+        #region グリッドマウスアップ
+        /// <summary>
+        /// グリッドマウスアップ
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvMain_MouseUp(object sender, MouseEventArgs e)
+        {
+            try
+            {
+                DataGridView dgv = (DataGridView)sender;
+
+                lblCellTotal.Text = string.Empty;
+
+                double dTotal = 0;
+                int DataCnt = 0;
+                int NumericCnt = 0;
+                foreach (DataGridViewCell c in dgv.SelectedCells)
+                {
+                    if (CommonMotions.chkObjectIsNull(dgv.Rows[c.RowIndex].Cells[c.ColumnIndex])) continue;
+                    if (CommonMotions.chkCellBlank(dgv.Rows[c.RowIndex].Cells[c.ColumnIndex].Value)) continue;
+
+                    Console.WriteLine("{0}, {1}", c.ColumnIndex, c.RowIndex);
+                    DataCnt++;
+                    dTotal += CommonMotions.cnvDouble(dgv.Rows[c.RowIndex].Cells[c.ColumnIndex].Value);
+                    if (CommonMotions.chkNumeric(dgv.Rows[c.RowIndex].Cells[c.ColumnIndex].Value)) NumericCnt++;
+                }
+                if (DataCnt <= 1 || dTotal == 0 || NumericCnt == 0) return;
+                string strTotal = CommonMotions.cnvTruncate(dTotal).ToString("#,#");
+                if (dTotal - System.Math.Floor(dTotal) != 0) strTotal = dTotal.ToString("#,#.00");
+
+                string strwrkData = string.Format(CommonDefine.s_CalculateCellFormat,
+                                                    CommonMotions.cnvTruncate(dTotal / (double)NumericCnt).ToString("#,#"),
+                                                    DataCnt.ToString("#,#"),
+                                                    strTotal);
+                lblCellTotal.Text = strwrkData;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
         #region 終了ボタン
         /// <summary>
         /// 終了ボタン押下
@@ -278,17 +327,37 @@
         /// </summary>
         private void DispData()
         {
+            DataGridView dgv = dgvMain;
             try
             {
-                dgvMain.Rows.Clear();
+                // 総合計エリア初期化
+                int TotalColCnt = Enum.GetNames(typeof(GridColumn)).Length;
+                m_TotalArea = new int[TotalColCnt];
+                Array.Clear(m_TotalArea, 0, m_TotalArea.Length);
 
-                // データ表示処理
-                SetRowData();
+                dgv.Rows.Clear();
+
+                // 台帳未作成データ表示処理
+                SetNotCreateRowData();
+
+                // 台帳データ表示
+                SetCreateRowData();
+
+                // 総合計を表示する
+                DisplayTotalRow((int)RowTitleNum.AllTotal, m_TotalArea);
+
             }
             catch (System.Exception ex)
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
+            finally
+            {
+                if (CommonDefine.s_MaxInitLineCount > dgv.RowCount)
+                {
+                    dgv.RowCount += CommonDefine.s_MaxInitLineCount - dgv.RowCount;
+                }
+            }
         }
         #endregion
 
@@ -349,11 +418,11 @@
         }
         #endregion
 
-        #region データ表示
+        #region 台帳未作成データ表示
         /// <summary>
-        /// データ表示処理
+        /// 台帳未作成データ表示処理
         /// </summary>
-        private void SetRowData()
+        private void SetNotCreateRowData()
         {
             IOConstructionBaseInfo BaseDB = new IOConstructionBaseInfo();
             DataGridView dgv = dgvMain;
@@ -420,10 +489,10 @@
                 if (!BaseDB.ExecuteReader(strSQL, ref DatArList)) return;
                 if (DatArList.Count == 0) return;
 
-                // 合計エリア
+                // 合計エリア初期化
                 int TotalColCnt = Enum.GetNames(typeof(GridColumn)).Length;
-                int[] TotalArea = new int[TotalColCnt];
-                Array.Clear(TotalArea, 0, TotalArea.Length);
+                int[] CurTotalArea = new int[TotalColCnt];
+                Array.Clear(CurTotalArea, 0, CurTotalArea.Length);
 
                 int ino = 1;
                 bool FirstFlg = true;
@@ -455,17 +524,132 @@
                                     , (OrdersDecisionPrice * ExpensesRatio3).ToString("#,0")                    // 営業経費
                                 );
 
-                    TotalArea[(int)GridColumn.OrdersPrice] += OrdersDecisionPrice;                                  // 受注金額
-                    TotalArea[(int)GridColumn.CompanyExpeses] += (int)(OrdersDecisionPrice * ExpensesRatio1);       // 会社経費
-                    TotalArea[(int)GridColumn.DepartmentExpeses] += (int)(OrdersDecisionPrice * ExpensesRatio2);    // 部署経費
-                    TotalArea[(int)GridColumn.SaleseExpeses] += (int)(OrdersDecisionPrice * ExpensesRatio3);        // 営業経費
+                    CurTotalArea[(int)GridColumn.OrdersPrice] += OrdersDecisionPrice;                                  // 受注金額
+                    CurTotalArea[(int)GridColumn.CompanyExpeses] += (int)(OrdersDecisionPrice * ExpensesRatio1);       // 会社経費
+                    CurTotalArea[(int)GridColumn.DepartmentExpeses] += (int)(OrdersDecisionPrice * ExpensesRatio2);    // 部署経費
+                    CurTotalArea[(int)GridColumn.SaleseExpeses] += (int)(OrdersDecisionPrice * ExpensesRatio3);        // 営業経費
                 }
 
                 // 合計行表示
+                DisplayTotalRow((int)RowTitleNum.DataType1, CurTotalArea, false);
+
+                m_TotalArea[(int)GridColumn.OrdersPrice] += CurTotalArea[(int)GridColumn.OrdersPrice];
+                m_TotalArea[(int)GridColumn.CompanyExpeses] += CurTotalArea[(int)GridColumn.OrdersPrice];
+                m_TotalArea[(int)GridColumn.DepartmentExpeses] += CurTotalArea[(int)GridColumn.OrdersPrice];
+                m_TotalArea[(int)GridColumn.SaleseExpeses] += CurTotalArea[(int)GridColumn.OrdersPrice];
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                BaseDB.close(); BaseDB = null;
+            }
+        }
+        #endregion
+
+        #region 台帳データ表示
+        /// <summary>
+        /// 台帳データ表示処理
+        /// </summary>
+        private void SetCreateRowData()
+        {
+            IOConstructionBaseInfo BaseDB = new IOConstructionBaseInfo();
+            DataGridView dgv = dgvMain;
+            try
+            {
+                int SelectPeriod = (int)numUDConstPro.Value;
+                // コンボボックスより選択部署を取得する
+                int DepartmantCode = GetDepartmentCode();
+                // コンボボックスより選択担当者を取得する
+                int PersonCode = GetConstructionPersonCode();
+
+                int iCode1 = CommonDefine.ProjectsStatus.First(x => x.Value.Equals("非 受 注")).Key;
+
+                string strSQL = "SELECT A.COMPLATEFLG, SUM(A.ORDERSDECISIONPRICE), SUM(A.COMPANYEXPENSES), SUM(A.DEPARTMENTEXPENSES), SUM(A.SALESEXPENSES)";
+                strSQL += " FROM CONSTRUCTIONLEDGER A, CONSTRUCTIONBASEINFO B, PERSONINCHARGEMASTER C";
+                strSQL += " WHERE A.CONSTRUCTIONCODE = B.CONSTRUCTIONCODE";
+                strSQL += string.Format(" AND B.CONSTRUCTIONPERIOD = {0}", SelectPeriod);
+                strSQL += string.Format(" AND B.CONSTRUCTIONSTATUSFLG != {0}", iCode1);
+                strSQL += " AND C.PERSONCODE = B.CONSTRUCTIONPERSONCODE";
+                if (DepartmantCode != 0) strSQL += string.Format(" AND C.DEPARTMENTCODE = {0}", DepartmantCode);
+                if (PersonCode != 0) strSQL += string.Format(" AND C.PERSONCODE = {0}", PersonCode);
+                strSQL += " GROUP BY A.COMPLATEFLG";
+                strSQL += " ORDER BY 1";
+
+                ArrayList DatArList = new ArrayList();
+                if (!BaseDB.ExecuteReader(strSQL, ref DatArList)) return;
+                if (DatArList.Count == 0) return;
+
+                // 合計エリア初期化
+                int TotalColCnt = Enum.GetNames(typeof(GridColumn)).Length;
+                int[] CurTotalArea = new int[TotalColCnt];
+                Array.Clear(CurTotalArea, 0, CurTotalArea.Length);
+
+                bool FirstFlg = true;
+                int BreakKey = -1;
+                foreach (object[] objGetArry in DatArList)
+                {
+                    int CompFlg = CommonMotions.cnvInt(objGetArry[0]);
+                    if (BreakKey != CompFlg)
+                    {
+                        if (!FirstFlg)
+                        {
+                            // 合計表示(施工中だけ表示)
+                            if (CompFlg == 0) DisplayTotalRow((int)RowTitleNum.DataType2, CurTotalArea);
+                        }
+                        Array.Clear(CurTotalArea, 0, CurTotalArea.Length);
+                        BreakKey = CompFlg;
+                        FirstFlg = false;
+                    }
+
+                    int OrdersDecisionPrice = CommonMotions.cnvInt(objGetArry[1]);      // 受注金額
+                    int ExpensesPrice1 = CommonMotions.cnvInt(objGetArry[2]);           // 会社経費
+                    int ExpensesPrice2 = CommonMotions.cnvInt(objGetArry[3]);           // 部署経費
+                    int ExpensesPrice3 = CommonMotions.cnvInt(objGetArry[4]);           // 営業経費
+
+                    CurTotalArea[(int)GridColumn.OrdersPrice] += OrdersDecisionPrice;   // 受注金額
+                    CurTotalArea[(int)GridColumn.CompanyExpeses] += ExpensesPrice1;     // 会社経費
+                    CurTotalArea[(int)GridColumn.DepartmentExpeses] += ExpensesPrice2;  // 部署経費
+                    CurTotalArea[(int)GridColumn.SaleseExpeses] += ExpensesPrice3;      // 営業経費
+
+                    m_TotalArea[(int)GridColumn.OrdersPrice] += CurTotalArea[(int)GridColumn.OrdersPrice];
+                    m_TotalArea[(int)GridColumn.CompanyExpeses] += CurTotalArea[(int)GridColumn.OrdersPrice];
+                    m_TotalArea[(int)GridColumn.DepartmentExpeses] += CurTotalArea[(int)GridColumn.OrdersPrice];
+                    m_TotalArea[(int)GridColumn.SaleseExpeses] += CurTotalArea[(int)GridColumn.OrdersPrice];
+                }
+
+                // 合計行表示
+                DisplayTotalRow((int)RowTitleNum.DataType3, CurTotalArea);
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                BaseDB.close(); BaseDB = null;
+            }
+        }
+        #endregion
+
+        #region 合計を表示
+        /// <summary>
+        /// 合計を表示する
+        /// </summary>
+        private void DisplayTotalRow(int TitleNo, int[] TotalArea, bool AddBrankRow= true)
+        {
+            try
+            {
+                DataGridView dgv = dgvMain;
+
+                if (AddBrankRow) dgv.Rows.Add(1);
+                // 合計行表示
                 int TotalRow = dgv.Rows.Add(1);
-                dgv.Rows[TotalRow].Cells[(int)GridColumn.ConstrName].Value = s_TotalTitleArray[(int)RowTitleNum.DataType1];
+                dgv.Rows[TotalRow].Cells[(int)GridColumn.ConstrName].Value = s_TotalTitleArray[TitleNo];
                 dgv.Rows[TotalRow].Cells[(int)GridColumn.ConstrName].Style.Alignment = DataGridViewContentAlignment.MiddleCenter;
-                    // 行の色を変える
+                // 行の色を変える
                 SetRowColor(dgv.Rows[TotalRow], s_RowTotalBackColor, s_RowTotalForeColor);
 
                 // 数値表示
@@ -478,14 +662,6 @@
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
-            finally
-            {
-                BaseDB.close(); BaseDB = null;
-                if (CommonDefine.s_MaxInitLineCount > dgv.RowCount)
-                {
-                    dgv.RowCount += CommonDefine.s_MaxInitLineCount - dgv.RowCount;
-                }
-            }
         }
         #endregion
 
@@ -534,20 +710,36 @@
                 string strSQL = string.Empty;
                 // 部署マスタを検索する
                 strSQL = "SELECT A.DEPARTMENTCODE, A.DEPARTMENTSTRING, A.DISPLAYORDER, COUNT(*)";
-                strSQL += " FROM DEPARTMENTMASTER A, PERSONINCHARGEMASTER B, CONSTRUCTIONBASEINFO C, CONSTRUCTIONBUDGET D";
+                strSQL += " FROM DEPARTMENTMASTER A, PERSONINCHARGEMASTER B, CONSTRUCTIONBASEINFO C";
                 strSQL += " WHERE A.DELETEFLG = 0";
 
-                // システム権限によってデータアクセスに制限がある
-                if (CommonMotions.LoginUserData.SecurityManagement == CommonDefine.SystemManageDiv[(int)CommonDefine.SysManaDivNo.SuperiorAuthority].Key
-                    || CommonMotions.LoginUserData.SecurityManagement == CommonDefine.SystemManageDiv[(int)CommonDefine.SysManaDivNo.UserAuthority].Key)
+                // 新セキュリティデータ対応済みかを確認する
+                if (CommonMotions.LoginUserData.SecCode == 0)
                 {
-                    // 所属長
-                    // 一般使用者（自分のみアクセス可能）
-                    strSQL += string.Format(" AND A.DEPARTMENTCODE = {0}", CommonMotions.LoginUserData.DepartmentCode);
+                    // システム権限によってデータアクセスに制限がある
+                    if (CommonMotions.LoginUserData.SecurityManagement == CommonDefine.SystemManageDiv[(int)CommonDefine.SysManaDivNo.SuperiorAuthority].Key
+                        || CommonMotions.LoginUserData.SecurityManagement == CommonDefine.SystemManageDiv[(int)CommonDefine.SysManaDivNo.UserAuthority].Key)
+                    {
+                        // 所属長
+                        // 一般使用者（自分のみアクセス可能）
+                        strSQL += string.Format(" AND A.DEPARTMENTCODE = {0}", CommonMotions.LoginUserData.DepartmentCode);
+                    }
                 }
+                else
+                {
+                    if (CommonMotions.LoginUserData.PersonCode == CommonDefine.AdminCode)
+                    {
+
+                    }
+                    else
+                    {
+                        // 参照部署マスタより取得する
+                        strSQL += " AND A.DEPARTMENTCODE IN (SELECT A1.DEPARTMENTCODE FROM PERSONDEPARTMENTMASTER A1";
+                        strSQL += string.Format(" WHERE A1.PERSONCODE = {0})", CommonMotions.LoginUserData.PersonCode);
+                    }
+                }
                 strSQL += " AND A.DEPARTMENTCODE = B.DEPARTMENTCODE";
                 strSQL += " AND B.PERSONCODE = C.CONSTRUCTIONPERSONCODE";
-                strSQL += " AND D.CONSTRUCTIONCODE = C.CONSTRUCTIONCODE";
                 strSQL += " GROUP BY A.DEPARTMENTCODE, A.DEPARTMENTSTRING, A.DISPLAYORDER";
                 strSQL += " ORDER BY A.DISPLAYORDER ASC";
 
@@ -570,15 +762,31 @@
                 // コンボボックス初期表示
                 ComboBoxAction.InitDataSetCombBox(cmbDepartment, ConstructionDataList);
 
-                // 所属長
-                // 一般使用者（自分のみアクセス可能）
-                if (CommonMotions.LoginUserData.SecurityManagement == CommonDefine.SystemManageDiv[(int)CommonDefine.SysManaDivNo.SuperiorAuthority].Key ||
-                    CommonMotions.LoginUserData.SecurityManagement == CommonDefine.SystemManageDiv[(int)CommonDefine.SysManaDivNo.UserAuthority].Key)
+                // 新セキュリティデータ対応済みかを確認する
+                if (CommonMotions.LoginUserData.SecCode == 0)
                 {
-                    // 総務部所属者以外
-                    if (CommonMotions.LoginUserData.DepartmentCode != CommonDefine.s_GeneralAffairsDevision)
-                        cmbDepartment.SelectedValue = CommonMotions.LoginUserData.DepartmentCode;
+                    // 所属長
+                    // 一般使用者（自分のみアクセス可能）
+                    if (CommonMotions.LoginUserData.SecurityManagement == CommonDefine.SystemManageDiv[(int)CommonDefine.SysManaDivNo.SuperiorAuthority].Key ||
+                        CommonMotions.LoginUserData.SecurityManagement == CommonDefine.SystemManageDiv[(int)CommonDefine.SysManaDivNo.UserAuthority].Key)
+                    {
+                        // 総務部所属者以外
+                        if (CommonMotions.LoginUserData.DepartmentCode != CommonDefine.s_GeneralAffairsDevision)
+                            cmbDepartment.SelectedValue = CommonMotions.LoginUserData.DepartmentCode;
+                    }
                 }
+                else
+                {
+                    // 対象がコンボボックスデータにあればセットする
+                    for (int i = 0; i < cmbDepartment.Items.Count; i++)
+                    {
+                        KeyValuePair<int, string> wrkPair = (KeyValuePair<int, string>)cmbDepartment.Items[i];
+                        if (wrkPair.Key == CommonMotions.LoginUserData.DepartmentCode)
+                        {
+                            cmbDepartment.SelectedValue = CommonMotions.LoginUserData.DepartmentCode;
+                        }
+                    }
+                }
 
                 return true;
             }
@@ -634,12 +842,27 @@
                 // コンボボックス初期表示
                 ComboBoxAction.InitDataSetCombBox(cmbConstructionPerson, ConstructionDataList);
 
-                // 一般ユーザーで総務部所属者ではない場合、ログイン者のコードをセットする
-                if (CommonMotions.LoginUserData.SecurityManagement == CommonDefine.SystemManageDiv[(int)CommonDefine.SysManaDivNo.UserAuthority].Key &&
-                    CommonMotions.LoginUserData.DepartmentCode != CommonDefine.s_GeneralAffairsDevision)
+                // 新セキュリティデータ対応済みかを確認する
+                if (CommonMotions.LoginUserData.SecCode == 0)
                 {
-                    cmbConstructionPerson.SelectedValue = CommonMotions.LoginUserData.PersonCode;
+                    // 一般ユーザーで総務部所属者ではない場合、ログイン者のコードをセットする
+                    if (CommonMotions.LoginUserData.SecurityManagement == CommonDefine.SystemManageDiv[(int)CommonDefine.SysManaDivNo.UserAuthority].Key &&
+                        CommonMotions.LoginUserData.DepartmentCode != CommonDefine.s_GeneralAffairsDevision)
+                    {
+                        cmbConstructionPerson.SelectedValue = CommonMotions.LoginUserData.PersonCode;
+                    }
                 }
+                else
+                {
+                    for (int i = 0; i < cmbConstructionPerson.Items.Count; i++)
+                    {
+                        KeyValuePair<int, string> wrkPair = (KeyValuePair<int, string>)cmbConstructionPerson.Items[i];
+                        if (wrkPair.Key == CommonMotions.LoginUserData.PersonCode)
+                        {
+                            cmbConstructionPerson.SelectedValue = CommonMotions.LoginUserData.PersonCode;
+                        }
+                    }
+                }
 
                 return true;
             }
@@ -721,18 +944,16 @@
                 PersonDB.SelectAction(strSQL, ref PersonRec);
 
                 // 部署コンボボックスへ部署コードセット
-                if (PersonRec.DepartmentCode < 0 || DepartmentCode == PersonRec.DepartmentCode) return true;
+                if (PersonRec.DepartmentCode > 0 && DepartmentCode != PersonRec.DepartmentCode)
+                {
+                    bool bSave = m_initDataLoad;
+                    m_initDataLoad = true;
+                    cmbDepartment.SelectedValue = PersonRec.DepartmentCode;
+                    SetcmbPersons();    // 担当者コンボボックス変更
+                    cmbConstructionPerson.SelectedValue = PersonCode;
+                    m_initDataLoad = bSave;
+                }
 
-                m_initDataLoad = true;
-
-                // 部署コードセット
-                cmbDepartment.SelectedValue = PersonRec.DepartmentCode;
-
-                // 担当者コード再セット
-                cmbConstructionPerson.SelectedValue = PersonCode;
-
-                m_initDataLoad = false;
-
                 return true;
             }
             catch (Exception ex)
